diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/ocelot.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/ocelot.c
--- linux-2.6.9-intc1/drivers/mtd/maps/ocelot.c	2004-10-18 17:55:28.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/ocelot.c	2005-03-21 21:28:42.000000000 -0500
@@ -1,5 +1,5 @@
 /*
- * $Id: ocelot.c,v 1.13 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: ocelot.c,v 1.16 2005/01/05 18:05:13 dwmw2 Exp $
  *
  * Flash on Momenco Ocelot
  */
@@ -28,7 +28,7 @@
 
 static void ocelot_ram_write(struct mtd_info *mtd, loff_t to, size_t len, size_t *retlen, const u_char *buf)
 {
-        struct map_info *map = (struct map_info *)mtd->priv;
+        struct map_info *map = mtd->priv;
 	size_t done = 0;
 
 	/* If we use memcpy, it does word-wide writes. Even though we told the 
@@ -81,7 +81,7 @@
 	iounmap(pld);
 
 	/* Now ioremap the NVRAM space */
-	ocelot_nvram_map.virt = (unsigned long)ioremap_nocache(NVRAM_WINDOW_ADDR, NVRAM_WINDOW_SIZE);
+	ocelot_nvram_map.virt = ioremap_nocache(NVRAM_WINDOW_ADDR, NVRAM_WINDOW_SIZE);
 	if (!ocelot_nvram_map.virt) {
 		printk(KERN_NOTICE "Failed to ioremap Ocelot NVRAM space\n");
 		return -EIO;
@@ -101,7 +101,7 @@
 	nvram_mtd->write = ocelot_ram_write;
 
 	/* Now map the flash space */
-	ocelot_flash_map.virt = (unsigned long)ioremap_nocache(FLASH_WINDOW_ADDR, FLASH_WINDOW_SIZE);
+	ocelot_flash_map.virt = ioremap_nocache(FLASH_WINDOW_ADDR, FLASH_WINDOW_SIZE);
 	if (!ocelot_flash_map.virt) {
 		printk(KERN_NOTICE "Failed to ioremap Ocelot flash space\n");
 		goto fail_2;
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/ocotea.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/ocotea.c
--- linux-2.6.9-intc1/drivers/mtd/maps/ocotea.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/ocotea.c	2005-03-21 21:28:43.000000000 -0500
@@ -0,0 +1,154 @@
+/*
+ * Mapping for Ocotea user flash
+ *
+ * Matt Porter <mporter@kernel.crashing.org>
+ *
+ * Copyright 2002-2004 MontaVista Software Inc.
+ *
+ * This program is free software; you can redistribute  it and/or modify it
+ * under  the terms of  the GNU General  Public License as published by the
+ * Free Software Foundation;  either version 2 of the  License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/partitions.h>
+#include <linux/config.h>
+#include <linux/version.h>
+#include <asm/io.h>
+#include <asm/ibm44x.h>
+#include <platforms/4xx/ocotea.h>
+
+static struct mtd_info *flash;
+
+static struct map_info ocotea_small_map = {
+	.name =		"Ocotea small flash",
+	.size =		OCOTEA_SMALL_FLASH_SIZE,
+	.buswidth =	1,
+};
+
+static struct map_info ocotea_large_map = {
+	.name =		"Ocotea large flash",
+	.size =		OCOTEA_LARGE_FLASH_SIZE,
+	.buswidth =	1,
+};
+
+static struct mtd_partition ocotea_small_partitions[] = {
+	{
+		.name =   "pibs",
+		.offset = 0x0,
+		.size =   0x100000,
+	}
+};
+
+static struct mtd_partition ocotea_large_partitions[] = {
+	{
+		.name =   "fs",
+		.offset = 0,
+		.size =   0x300000,
+	},
+	{
+		.name =   "firmware",
+		.offset = 0x300000,
+		.size =   0x100000,
+	}
+};
+
+#define NB_OF(x)  (sizeof(x)/sizeof(x[0]))
+
+int __init init_ocotea(void)
+{
+	u8 fpga0_reg;
+	u8 *fpga0_adr;
+	unsigned long long small_flash_base, large_flash_base;
+
+	fpga0_adr = ioremap64(OCOTEA_FPGA_ADDR, 16);
+	if (!fpga0_adr)
+		return -ENOMEM;
+
+	fpga0_reg = readb((unsigned long)fpga0_adr);
+	iounmap(fpga0_adr);
+
+	if (OCOTEA_BOOT_LARGE_FLASH(fpga0_reg)) {
+		small_flash_base = OCOTEA_SMALL_FLASH_HIGH;
+		large_flash_base = OCOTEA_LARGE_FLASH_LOW;
+	}
+	else {
+		small_flash_base = OCOTEA_SMALL_FLASH_LOW;
+		large_flash_base = OCOTEA_LARGE_FLASH_HIGH;
+	}
+
+	ocotea_small_map.phys = small_flash_base;
+	ocotea_small_map.virt = ioremap64(small_flash_base,
+					 ocotea_small_map.size);
+
+	if (!ocotea_small_map.virt) {
+		printk("Failed to ioremap flash\n");
+		return -EIO;
+	}
+
+	simple_map_init(&ocotea_small_map);
+
+	flash = do_map_probe("map_rom", &ocotea_small_map);
+	if (flash) {
+		flash->owner = THIS_MODULE;
+		add_mtd_partitions(flash, ocotea_small_partitions,
+					NB_OF(ocotea_small_partitions));
+	} else {
+		printk("map probe failed for flash\n");
+		return -ENXIO;
+	}
+
+	ocotea_large_map.phys = large_flash_base;
+	ocotea_large_map.virt = ioremap64(large_flash_base,
+					 ocotea_large_map.size);
+
+	if (!ocotea_large_map.virt) {
+		printk("Failed to ioremap flash\n");
+		return -EIO;
+	}
+
+	simple_map_init(&ocotea_large_map);
+
+	flash = do_map_probe("cfi_probe", &ocotea_large_map);
+	if (flash) {
+		flash->owner = THIS_MODULE;
+		add_mtd_partitions(flash, ocotea_large_partitions,
+					NB_OF(ocotea_large_partitions));
+	} else {
+		printk("map probe failed for flash\n");
+		return -ENXIO;
+	}
+
+	return 0;
+}
+
+static void __exit cleanup_ocotea(void)
+{
+	if (flash) {
+		del_mtd_partitions(flash);
+		map_destroy(flash);
+	}
+
+	if (ocotea_small_map.virt) {
+		iounmap((void *)ocotea_small_map.virt);
+		ocotea_small_map.virt = 0;
+	}
+
+	if (ocotea_large_map.virt) {
+		iounmap((void *)ocotea_large_map.virt);
+		ocotea_large_map.virt = 0;
+	}
+}
+
+module_init(init_ocotea);
+module_exit(cleanup_ocotea);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Matt Porter <mporter@kernel.crashing.org>");
+MODULE_DESCRIPTION("MTD map and partitions for IBM 440GX Ocotea boards");
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/octagon-5066.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/octagon-5066.c
--- linux-2.6.9-intc1/drivers/mtd/maps/octagon-5066.c	2004-10-18 17:53:22.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/octagon-5066.c	2005-03-21 21:28:42.000000000 -0500
@@ -1,4 +1,4 @@
-// $Id: octagon-5066.c,v 1.26 2004/07/12 22:38:29 dwmw2 Exp $
+// $Id: octagon-5066.c,v 1.27 2005/01/12 22:34:35 gleixner Exp $
 /* ######################################################################
 
    Octagon 5066 MTD Driver. 
@@ -41,7 +41,7 @@
 
 static volatile char page_n_dev = 0;
 static unsigned long iomapadr;
-static spinlock_t oct5066_spin = SPIN_LOCK_UNLOCKED;
+static DEFINE_SPINLOCK(oct5066_spin);
 
 /*
  * We use map_priv_1 to identify which device we are.
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/omap-toto-flash.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/omap-toto-flash.c
--- linux-2.6.9-intc1/drivers/mtd/maps/omap-toto-flash.c	2004-10-18 17:53:45.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/omap-toto-flash.c	2005-03-21 21:28:43.000000000 -0500
@@ -5,7 +5,7 @@
  *
  *  (C) 2002 MontVista Software, Inc.
  *
- * $Id: omap-toto-flash.c,v 1.2 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: omap-toto-flash.c,v 1.3 2004/09/16 23:27:13 gleixner Exp $
  */
 
 #include <linux/config.h>
@@ -35,7 +35,7 @@
 static struct map_info omap_toto_map_flash = {
 	.name =		"OMAP Toto flash",
 	.bankwidth =	2,
-	.virt =		OMAP_TOTO_FLASH_BASE,
+	.virt =		(void __iomem *)OMAP_TOTO_FLASH_BASE,
 };
 
  
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/pci.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/pci.c
--- linux-2.6.9-intc1/drivers/mtd/maps/pci.c	2004-10-18 17:53:51.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/pci.c	2005-03-21 21:28:42.000000000 -0500
@@ -7,7 +7,7 @@
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  *
- *  $Id: pci.c,v 1.8 2004/07/12 22:38:29 dwmw2 Exp $
+ *  $Id: pci.c,v 1.10 2005/03/18 14:04:35 gleixner Exp $
  * 
  * Generic PCI memory map driver.  We support the following boards:
  *  - Intel IQ80310 ATU.
@@ -33,7 +33,7 @@
 
 struct map_pci_info {
 	struct map_info map;
-	void *base;
+	void __iomem *base;
 	void (*exit)(struct pci_dev *dev, struct map_pci_info *map);
 	unsigned long (*translate)(struct map_pci_info *map, unsigned long ofs);
 	struct pci_dev *dev;
@@ -143,7 +143,7 @@
 intel_iq80310_exit(struct pci_dev *dev, struct map_pci_info *map)
 {
 	if (map->base)
-		iounmap((void *)map->base);
+		iounmap(map->base);
 	pci_write_config_dword(dev, 0x44, map->map.map_priv_2);
 }
 
@@ -236,7 +236,7 @@
 	u32 val;
 
 	if (map->base)
-		iounmap((void *)map->base);
+		iounmap(map->base);
 
 	/*
 	 * We need to undo the PCI BAR2/PCI ROM BAR address alteration.
@@ -370,7 +370,7 @@
 
 static int __init mtd_pci_maps_init(void)
 {
-	return pci_module_init(&mtd_pci_driver);
+	return pci_register_driver(&mtd_pci_driver);
 }
 
 static void __exit mtd_pci_maps_exit(void)
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/pcmciamtd.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/pcmciamtd.c
--- linux-2.6.9-intc1/drivers/mtd/maps/pcmciamtd.c	2004-10-18 17:53:21.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/pcmciamtd.c	2005-03-21 21:28:42.000000000 -0500
@@ -1,5 +1,5 @@
 /*
- * $Id: pcmciamtd.c,v 1.51 2004/07/12 22:38:29 dwmw2 Exp $
+ * $Id: pcmciamtd.c,v 1.52 2005/03/17 20:05:37 gleixner Exp $
  *
  * pcmciamtd.c - MTD driver for PCMCIA flash memory cards
  *
@@ -49,7 +49,7 @@
 
 
 #define DRIVER_DESC	"PCMCIA Flash memory card driver"
-#define DRIVER_VERSION	"$Revision: 1.51 $"
+#define DRIVER_VERSION	"$Revision: 1.52 $"
 
 /* Size of the PCMCIA address space: 26 bits = 64 MB */
 #define MAX_PCMCIA_ADDR	0x4000000
@@ -800,7 +800,6 @@
 
 	/* Register with Card Services */
 	client_reg.dev_info = &dev_info;
-	client_reg.Attributes = INFO_IO_CLIENT | INFO_CARD_SHARE;
 	client_reg.EventMask =
 		CS_EVENT_RESET_PHYSICAL | CS_EVENT_CARD_RESET |
 		CS_EVENT_CARD_INSERTION | CS_EVENT_CARD_REMOVAL |
@@ -854,35 +853,7 @@
 {
 	DEBUG(1, DRIVER_DESC " unloading");
 	pcmcia_unregister_driver(&pcmciamtd_driver);
-
-	while(dev_list) {
-		dev_link_t *link = dev_list;
-
-		dev_list = link->next;
-		if (link) {
-			struct pcmciamtd_dev *dev = link->priv;
-			
- 			if(dev) {
-				if(link->state & DEV_PRESENT) {
-					if (!(link->state & DEV_STALE_LINK)) {
-						pcmciamtd_detach(link);
-					}
-					link->state &= ~DEV_PRESENT;
-					if(dev->mtd_info) {
-						del_mtd_device(dev->mtd_info);
-						info("mtd%d: Removed",
-						     dev->mtd_info->index);
-					}
-				}
-				if(dev->mtd_info) {
-					DEBUG(2, "Destroying map for mtd%d",
-					      dev->mtd_info->index);
-					map_destroy(dev->mtd_info);
-				}
-				kfree(dev);
-			}
-		}
-	}
+	BUG_ON(dev_list != NULL);
 }
 
 module_init(init_pcmciamtd);
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/physmap.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/physmap.c
--- linux-2.6.9-intc1/drivers/mtd/maps/physmap.c	2004-10-18 17:54:37.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/physmap.c	2005-04-19 15:02:37.000000000 -0400
@@ -1,5 +1,5 @@
 /*
- * $Id: physmap.c,v 1.34 2004/07/21 00:16:14 jwboyer Exp $
+ * $Id: physmap.c,v 1.37 2004/11/28 09:40:40 dwmw2 Exp $
  *
  * Normal mappings of chips in physical memory
  *
@@ -51,7 +51,7 @@
 	const char **type;
 
        	printk(KERN_NOTICE "physmap flash device: %lx at %lx\n", physmap_map.size, physmap_map.phys);
-	physmap_map.virt = (unsigned long)ioremap(physmap_map.phys, physmap_map.size);
+	physmap_map.virt = ioremap(physmap_map.phys, physmap_map.size);
 
 	if (!physmap_map.virt) {
 		printk("Failed to ioremap\n");
@@ -68,6 +68,8 @@
 	if (mymtd) {
 		mymtd->owner = THIS_MODULE;
 
+		add_mtd_device(mymtd);
+
 #ifdef CONFIG_MTD_PARTITIONS
 		mtd_parts_nb = parse_mtd_partitions(mymtd, part_probes, 
 						    &mtd_parts, 0);
@@ -87,12 +89,11 @@
 		}
 
 #endif
-		add_mtd_device(mymtd);
 
 		return 0;
 	}
 
-	iounmap((void *)physmap_map.virt);
+	iounmap(physmap_map.virt);
 	return -ENXIO;
 }
 
@@ -112,8 +113,8 @@
 #endif
 	map_destroy(mymtd);
 
-	iounmap((void *)physmap_map.virt);
-	physmap_map.virt = 0;
+	iounmap(physmap_map.virt);
+	physmap_map.virt = NULL;
 }
 
 module_init(init_physmap);
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/plat-ram.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/plat-ram.c
--- linux-2.6.9-intc1/drivers/mtd/maps/plat-ram.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/plat-ram.c	2005-03-21 21:28:43.000000000 -0500
@@ -0,0 +1,278 @@
+/* drivers/mtd/maps/plat-ram.c
+ *
+ * (c) 2004-2005 Simtec Electronics
+ *	http://www.simtec.co.uk/products/SWLINUX/
+ *	Ben Dooks <ben@simtec.co.uk>
+ *
+ * Generic platfrom device based RAM map
+ *
+ * $Id: plat-ram.c,v 1.3 2005/03/19 22:41:27 gleixner Exp $
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/string.h>
+#include <linux/ioport.h>
+#include <linux/device.h>
+
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/partitions.h>
+#include <linux/mtd/plat-ram.h>
+
+#include <asm/io.h>
+
+/* private structure for each mtd platform ram device created */
+
+struct platram_info {
+	struct device		*dev;
+	struct mtd_info		*mtd;
+	struct map_info		 map;
+	struct mtd_partition	*partitions;
+	struct resource		*area;
+	struct platdata_mtd_ram	*pdata;
+};
+
+/* to_platram_info()
+ *
+ * device private data to struct platram_info conversion
+*/
+
+static inline struct platram_info *to_platram_info(struct device *dev)
+{
+	return (struct platram_info *)dev_get_drvdata(dev);
+}
+
+/* platram_setrw
+ *
+ * call the platform device's set rw/ro control
+ *
+ * to = 0 => read-only
+ *    = 1 => read-write
+*/
+
+static inline void platram_setrw(struct platram_info *info, int to)
+{
+	if (info->pdata == NULL)
+		return;
+
+	if (info->pdata->set_rw != NULL)
+		(info->pdata->set_rw)(info->dev, to);
+}
+
+/* platram_remove
+ *
+ * called to remove the device from the driver's control
+*/
+
+static int platram_remove(struct device *dev)
+{
+	struct platram_info *info = to_platram_info(dev);
+
+	dev_set_drvdata(dev, NULL);
+
+	dev_dbg(dev, "removing device\n");
+
+	if (info == NULL) 
+		return 0;
+
+	if (info->mtd) {
+#ifdef CONFIG_MTD_PARTITIONS
+		if (info->partitions) {
+			del_mtd_partitions(info->mtd);
+			kfree(info->partitions);
+		}
+#endif
+		del_mtd_device(info->mtd);
+		map_destroy(info->mtd);
+	}
+
+	/* ensure ram is left read-only */
+
+	platram_setrw(info, PLATRAM_RO);
+
+	/* release resources */
+
+	if (info->area) {
+		release_resource(info->area);
+		kfree(info->area);
+	}
+
+	if (info->map.virt != NULL)
+		iounmap(info->map.virt);
+	
+	kfree(info);
+
+	return 0;
+}
+
+/* platram_probe
+ *
+ * called from device drive system when a device matching our
+ * driver is found.
+*/
+
+static int platram_probe(struct device *dev)
+{
+	struct platform_device *pd = to_platform_device(dev);
+	struct platdata_mtd_ram	*pdata;
+	struct platram_info *info;
+	struct resource *res;
+	int err = 0;
+
+	dev_dbg(dev, "probe entered\n");
+	
+	if (dev->platform_data == NULL) {
+		dev_err(dev, "no platform data supplied\n");
+		err = -ENOENT;
+		goto exit_error;
+	}
+
+	pdata = dev->platform_data;
+
+	info = kmalloc(sizeof(*info), GFP_KERNEL);
+	if (info == NULL) {
+		dev_err(dev, "no memory for flash info\n");
+		err = -ENOMEM;
+		goto exit_error;
+	}
+
+	memset(info, 0, sizeof(*info));
+	dev_set_drvdata(dev, info);
+
+	info->dev = dev;
+	info->pdata = pdata;
+
+	/* get the resource for the memory mapping */
+
+	res = platform_get_resource(pd, IORESOURCE_MEM, 0);
+
+	if (res == NULL) {
+		dev_err(dev, "no memory resource specified\n");
+		err = -ENOENT;
+		goto exit_free;
+	}
+
+	dev_dbg(dev, "got platform resource %p (0x%lx)\n", res, res->start);
+
+	/* setup map parameters */
+
+	info->map.phys = res->start;
+	info->map.size = (res->end - res->start) + 1;
+	info->map.name = pdata->mapname != NULL ? pdata->mapname : pd->name;
+	info->map.bankwidth = pdata->bankwidth;
+
+	/* register our usage of the memory area */
+
+	info->area = request_mem_region(res->start, info->map.size, pd->name);
+	if (info->area == NULL) {
+		dev_err(dev, "failed to request memory region\n");
+		err = -EIO;
+		goto exit_free;
+	}
+
+	/* remap the memory area */
+
+	info->map.virt = ioremap(res->start, info->map.size);
+	dev_dbg(dev, "virt %p, %lu bytes\n", info->map.virt, info->map.size);
+
+	if (info->map.virt == NULL) {
+		dev_err(dev, "failed to ioremap() region\n");
+		err = -EIO;
+		goto exit_free;
+	}
+
+	simple_map_init(&info->map);
+
+	dev_dbg(dev, "initialised map, probing for mtd\n");
+
+	/* probe for the right mtd map driver */
+
+	info->mtd = do_map_probe("map_ram" , &info->map);
+	if (info->mtd == NULL) {
+		dev_err(dev, "failed to probe for map_ram\n");
+		err = -ENOMEM;
+		goto exit_free;
+	}
+
+	info->mtd->owner = THIS_MODULE;
+
+	platram_setrw(info, PLATRAM_RW);
+
+	/* check to see if there are any available partitions, or wether
+	 * to add this device whole */
+
+#ifdef CONFIG_MTD_PARTITIONS
+	if (pdata->nr_partitions > 0) {
+		const char **probes = { NULL };
+
+		if (pdata->probes)
+			probes = (const char **)pdata->probes;
+
+		err = parse_mtd_partitions(info->mtd, probes,
+					   &info->partitions, 0);
+		if (err > 0) {
+			err = add_mtd_partitions(info->mtd, info->partitions,
+						 err);
+		}
+	}
+#endif /* CONFIG_MTD_PARTITIONS */
+
+	if (add_mtd_device(info->mtd)) {
+		dev_err(dev, "add_mtd_device() failed\n");
+		err = -ENOMEM;
+	}
+	
+	dev_info(dev, "registered mtd device\n");
+	return err;
+
+ exit_free:
+	platram_remove(dev);
+ exit_error:
+	return err;
+}
+
+/* device driver info */
+
+static struct device_driver platram_driver = {
+	.name		= "mtd-ram",
+	.bus		= &platform_bus_type,
+	.probe		= platram_probe,
+	.remove		= platram_remove,
+};
+
+/* module init/exit */
+
+static int __init platram_init(void)
+{
+	printk("Generic platform RAM MTD, (c) 2004 Simtec Electronics\n");
+	return driver_register(&platram_driver);
+}
+
+static void __exit platram_exit(void)
+{
+	driver_unregister(&platram_driver);
+}
+
+module_init(platram_init);
+module_exit(platram_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Ben Dooks <ben@simtec.co.uk>");
+MODULE_DESCRIPTION("MTD platform RAM map driver");
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/pnc2000.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/pnc2000.c
--- linux-2.6.9-intc1/drivers/mtd/maps/pnc2000.c	2004-10-18 17:54:08.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/pnc2000.c	2005-03-21 21:28:42.000000000 -0500
@@ -5,7 +5,7 @@
  *
  * This code is GPL
  *
- * $Id: pnc2000.c,v 1.15 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: pnc2000.c,v 1.17 2004/11/16 18:29:02 dwmw2 Exp $
  */
 
 #include <linux/module.h>
@@ -26,12 +26,12 @@
  */
 
 
-struct map_info pnc_map = {
+static struct map_info pnc_map = {
 	.name = "PNC-2000",
 	.size = WINDOW_SIZE,
 	.bankwidth = 4,
 	.phys = 0xFFFFFFFF,
-	.virt = WINDOW_ADDR,
+	.virt = (void __iomem *)WINDOW_ADDR,
 };
 
 
@@ -62,7 +62,7 @@
  */
 static struct mtd_info *mymtd;
 
-int __init init_pnc2000(void)
+static int __init init_pnc2000(void)
 {
 	printk(KERN_NOTICE "Photron PNC-2000 flash mapping: %x at %x\n", WINDOW_SIZE, WINDOW_ADDR);
 
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/pxa27x-flash.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/pxa27x-flash.c
--- linux-2.6.9-intc1/drivers/mtd/maps/pxa27x-flash.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/pxa27x-flash.c	2005-05-01 00:34:51.000000000 -0400
@@ -4,6 +4,7 @@
  * Modified from linux/drivers/mtd/maps/lubbock-flash.c
  *
  * Copyright (C) 2004, Intel Corporation. 
+ * Modified and extended by Matthias Ihmig <m.ihmig@mytum.de>
  * 
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -11,6 +12,7 @@
  */
 
 #include <linux/module.h>
+#include <linux/moduleparam.h>
 #include <linux/types.h>
 #include <linux/kernel.h>
 #include <linux/init.h>
@@ -24,41 +26,73 @@
 #include <asm/pgtable.h>
 #include <asm/arch/pxa-regs.h>
 
+// Size of complete available flash memory in bytes
+#define WINDOW_SIZE 	(CONFIG_MTD_PXA27x_WINDOWSIZE * 1024 * 1024)
 
-#define WINDOW_SIZE 	64*1024*1024
+/* Size settings (in bytes) and calculations for default flash partition table */
+#define BLOB_FLASH_LEN		(256 * 1024)
+#define KERNEL_FLASH_LEN	(2 * 1024 * 1024)
+// RAMDISK_FLASH_LEN takes up the remainder and is calculated a few lines later
+#define PARAM_FLASH_LEN		(256 * 1024)
+
+#define BLOB_FLASH_BASE		(0x00000000)
+#define KERNEL_FLASH_BASE	(BLOB_FLASH_BASE + BLOB_FLASH_LEN)
+#define RAMDISK_FLASH_BASE	(KERNEL_FLASH_BASE + KERNEL_FLASH_LEN)
+
+#define RAMDISK_FLASH_LEN	(WINDOW_SIZE - KERNEL_FLASH_LEN - PARAM_FLASH_LEN - BLOB_FLASH_LEN)
+
+#define PARAM_FLASH_BASE	(RAMDISK_FLASH_BASE + RAMDISK_FLASH_LEN)
+
+
+/* Uncomment define to use cached memory access to flash
+ *
+ * This should not be used, as mtdblock already does caching thus
+ * making caching on this level unnecessary!
+ * 
+ * Also, data may be lost in case of a sudden power-off (which may occur
+ * esp. in mobile devices
+ */
+//#define USE_CACHED_FLASH
 
 struct pxa27x_flash_info {
 	struct mtd_info *mtd;
-	struct mtd_partition * part;
+	struct mtd_partition *part;
 	struct map_info *map;
 	int nparts;
 };	
 
+#ifdef USE_CACHED_FLASH
 static void pxa27x_map_inval_cache(struct map_info *map, unsigned long from, ssize_t len)
 {
 	consistent_sync((char *)map->cached + from, len, DMA_FROM_DEVICE);
 }
+#endif
 
+// don't use spaces within the name or else the cmdline partition table parser won't work
 static struct map_info pxa27x_map = {
 	.size =		WINDOW_SIZE,
 	.phys =		0x00000000,
-	.inval_cache = 	pxa27x_map_inval_cache,
+	.name =		"pxa27x-flash"
 };
 
 static struct mtd_partition pxa27x_partitions[] = {
 	{
-		.name =		"Bootloader",
-		.size =		0x00040000,
-		.offset =	0,
-		.mask_flags =	MTD_WRITEABLE  /* force read-only */
+		name:		"Bootloader",
+		size:		BLOB_FLASH_LEN,
+		offset:		BLOB_FLASH_BASE,
+//		mask_flags:	MTD_WRITEABLE  /* uncomment to enforce read-only partition */
 	},{
-		.name =		"Kernel",
-		.size =		0x00200000,
-		.offset =	0x00040000,
+		name:		"Kernel",
+		size:		KERNEL_FLASH_LEN,
+		offset:		KERNEL_FLASH_BASE
 	},{
-		.name =		"Filesystem",
-		.size =		0x01000000,
-		.offset =	0x00240000
+		name:		"Filesystem",
+		size:		RAMDISK_FLASH_LEN,
+		offset:		RAMDISK_FLASH_BASE
+	} ,{
+		name:   	"Param",
+		size:  		PARAM_FLASH_LEN,
+		offset:		PARAM_FLASH_BASE
 	}
 };
 
@@ -84,18 +118,22 @@
 	dev_set_drvdata(dev, info);
 
 	pxa27x_map.bankwidth = (BOOT_DEF & 1) ? 2 : 4;
+	pxa27x_map.cached = NULL;
 
-	pxa27x_map.name = "Intel PXA27x On-Chip ROM";
-
-	pxa27x_map.virt = (unsigned long)ioremap(pxa27x_map.phys, WINDOW_SIZE);
+	pxa27x_map.virt = ioremap(pxa27x_map.phys, pxa27x_map.size);
 	if (!pxa27x_map.virt) {
 		printk(KERN_WARNING "Failed to ioremap %s\n", pxa27x_map.name);
 		err = -ENOMEM;
 		goto Error;
 	}
+#ifdef USE_CACHED_FLASH
+	pxa27x_map.inval_cache = pxa27x_map_inval_cache;
 	pxa27x_map.cached = __ioremap(pxa27x_map.phys, WINDOW_SIZE, L_PTE_CACHEABLE, 1);
 	if (!pxa27x_map.cached)
 		printk(KERN_WARNING "Failed to ioremap cached %s\n", pxa27x_map.name);
+	else
+		printk(KERN_INFO "Using cached access to flash memory! Do you really want to do this?\n");
+#endif
 
 	simple_map_init(&pxa27x_map);
 
@@ -111,6 +149,7 @@
 		err = -EIO;
 		goto Error;
 	}
+	mymtd->owner = THIS_MODULE;
 
 	/* Unlock the flash device. */
 	for (i = 0; i < mymtd->numeraseregions; i++) {
@@ -122,7 +161,6 @@
 		}
 	}
 
-	mymtd->owner = THIS_MODULE;
 
 	ret = parse_mtd_partitions(mymtd, probes, &parsed_parts, 0);
 
@@ -154,10 +192,15 @@
 
 	if (!mymtd) return 0;
 
-	del_mtd_partitions(mymtd);
+	if (nr_parsed_part)
+		del_mtd_partitions(mymtd);
+	else
+		del_mtd_device(mymtd);
+	
 	map_destroy(mymtd);
 
-	iounmap((void *)pxa27x_map.virt);
+	if (pxa27x_map.virt)
+		iounmap((void *)pxa27x_map.virt);
 
 	if (pxa27x_map.cached) iounmap(pxa27x_map.cached);
 
@@ -200,7 +243,6 @@
 			}
 		}
 	}
-
 	return 0;
 }
 
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/redwood.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/redwood.c
--- linux-2.6.9-intc1/drivers/mtd/maps/redwood.c	2004-10-18 17:54:39.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/redwood.c	2005-03-21 21:28:42.000000000 -0500
@@ -1,5 +1,5 @@
 /*
- * $Id: redwood.c,v 1.8 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: redwood.c,v 1.10 2004/11/04 13:24:15 gleixner Exp $
  *
  * drivers/mtd/maps/redwood.c
  *
@@ -131,8 +131,7 @@
 	printk(KERN_NOTICE "redwood: flash mapping: %x at %x\n",
 			WINDOW_SIZE, WINDOW_ADDR);
 
-	redwood_flash_map.virt =
-		(unsigned long)ioremap(WINDOW_ADDR, WINDOW_SIZE);
+	redwood_flash_map.virt = ioremap(WINDOW_ADDR, WINDOW_SIZE);
 
 	if (!redwood_flash_map.virt) {
 		printk("init_redwood_flash: failed to ioremap\n");
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/rpxlite.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/rpxlite.c
--- linux-2.6.9-intc1/drivers/mtd/maps/rpxlite.c	2004-10-18 17:55:29.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/rpxlite.c	2005-03-21 21:28:42.000000000 -0500
@@ -1,5 +1,5 @@
 /*
- * $Id: rpxlite.c,v 1.20 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: rpxlite.c,v 1.22 2004/11/04 13:24:15 gleixner Exp $
  *
  * Handle mapping of the flash on the RPX Lite and CLLF boards
  */
@@ -28,7 +28,7 @@
 int __init init_rpxlite(void)
 {
 	printk(KERN_NOTICE "RPX Lite or CLLF flash device: %x at %x\n", WINDOW_SIZE*4, WINDOW_ADDR);
-	rpxlite_map.virt = (unsigned long)ioremap(WINDOW_ADDR, WINDOW_SIZE * 4);
+	rpxlite_map.virt = ioremap(WINDOW_ADDR, WINDOW_SIZE * 4);
 
 	if (!rpxlite_map.virt) {
 		printk("Failed to ioremap\n");
diff -Nur linux-2.6.9-intc1/drivers/mtd/maps/sa1100-flash.c linux-2.6.9-intc1-mih1/drivers/mtd/maps/sa1100-flash.c
--- linux-2.6.9-intc1/drivers/mtd/maps/sa1100-flash.c	2004-10-18 17:53:44.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/maps/sa1100-flash.c	2005-03-21 21:28:42.000000000 -0500
@@ -3,9 +3,8 @@
  * 
  * (C) 2000 Nicolas Pitre <nico@cam.org>
  * 
- * $Id: sa1100-flash.c,v 1.39 2004/07/12 21:59:44 dwmw2 Exp $
+ * $Id: sa1100-flash.c,v 1.48 2005/03/18 02:01:48 gleixner Exp $
  */
-
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/types.h>
